// etoy.BROOD - Gwangju2010
// soundcard MAYA 44usb - testFile4.0








// import JSyn libs
import com.softsynth.jsyn.*;
import com.softsynth.jsyn.util.SampleQueueOutputStream;

int numSoundDevices = 5;
SynthContext synthContextDefaultOut;
SynthContext synthContextDefaultIn;
SynthContext synthContextMAYA44_01;
SynthContext synthContextMAYA44_02;
SynthContext synthContextSoundflower16ch;
SynthContext synthContext[];
SynthContext synthContextOut;

Hashtable namesToDevice;
public final static int INPUT_MODE = 0;
public final static int OUTPUT_MODE = 1;

int mode;
int startTest=0;

// Devices
DeviceItem items[];
int deviceID;
int inDevID;

// Sounds object
ArrayList streamer = new ArrayList();
SampleFileStreamer streamer02;
File sampleFile;





/* SETUP */
void setup() {
  size(600, 300);
  
  // Make sure we are using the necessary version of JSyn.
  // We are using the new V144 latency methods.
  Synth.requestVersion( 144 );
  
  // Start synthesis engine.
  Synth.startEngine(0);
  
  //Synth.setTrace( Synth.VERBOSE );
  try {
    // Create a unique SynthContext so that this Applet will not
    // interfere with other Applets. 
    synthContextDefaultIn = new SynthContext();
    synthContextDefaultIn.initialize();
    synthContextDefaultOut = new SynthContext();
    synthContextDefaultOut.initialize();
    synthContextMAYA44_01 = new SynthContext();
    synthContextMAYA44_01.initialize();
    synthContextMAYA44_02 = new SynthContext();
    synthContextMAYA44_02.initialize();
    synthContextSoundflower16ch = new SynthContext();
    synthContextSoundflower16ch.initialize();
  } catch ( SynthException e ) {
    SynthAlert.showError( this, e );
  }
          
  // Latency I/IO
  synthContextDefaultIn.setSuggestedInputLatency( 44100 );
  synthContextDefaultIn.setSuggestedOutputLatency( 44100 );
  synthContextDefaultOut.setSuggestedInputLatency( 44100 );
  synthContextDefaultOut.setSuggestedOutputLatency( 44100 );
  synthContextMAYA44_01.setSuggestedInputLatency( 44100 );
  synthContextMAYA44_01.setSuggestedOutputLatency( 44100 );
  synthContextMAYA44_02.setSuggestedInputLatency( 44100 );
  synthContextMAYA44_02.setSuggestedOutputLatency( 44100 );
  synthContextSoundflower16ch.setSuggestedInputLatency( 44100 );
  synthContextSoundflower16ch.setSuggestedOutputLatency( 44100 );
   
  println("");
  println("There are "+AudioDevice.getNumDevices()+" available.");
  println("");
  
  // items objectArray
  items = new DeviceItem[AudioDevice.getNumDevices()];
  
  int devMAYA44=0;
  
  // Loop though all of the available devices 
  for( int i = 0; i < AudioDevice.getNumDevices(); i++ ) {
    int maxChannelsIn = getMaxChannels( i )[0];
    int maxChannelsOut = getMaxChannels( i )[1];
    if( maxChannelsIn > 0 || maxChannelsOut > 0) {
      println("Device: ID-Nr. "+i+" - "+AudioDevice.getName(i));
      println("InputChannels: "+AudioDevice.getMaxInputChannels(i));
      println("OutputChannels: "+AudioDevice.getMaxOutputChannels(i));
      println("");
            
      items[i] = new DeviceItem( i, AudioDevice.getName( i ), maxChannelsIn,  maxChannelsOut);
       
       // map 2nd MAYA44 USB
       if (AudioDevice.getName(i).indexOf("MAYA44") == 0) {
          devMAYA44+=1;
       }

       // start synthContext
       if (AudioDevice.getName(i).indexOf("Eingang") == 0) {
         //synthContextDefaultIn.start( 0, Synth.DEFAULT_FRAME_RATE, i, maxChannelsIn, i, Synth.NO_DEVICE );
       } else if (AudioDevice.getName(i).indexOf("Ausgang") == 0) {
         //synthContextDefaultOut.start( 0, Synth.DEFAULT_FRAME_RATE, i, Synth.NO_DEVICE, i, maxChannelsOut );
       } else if (AudioDevice.getName(i).indexOf("MAYA44") == 0 && devMAYA44==1) {
         synthContextMAYA44_01.start( 0, Synth.DEFAULT_FRAME_RATE, i, maxChannelsIn, i, maxChannelsOut );
       } else if (AudioDevice.getName(i).indexOf("MAYA44") == 0 && devMAYA44==2) {
         synthContextMAYA44_02.start( 0, Synth.DEFAULT_FRAME_RATE, i, maxChannelsIn, i, maxChannelsOut );
       } else if (AudioDevice.getName(i).indexOf("Soundflower (16ch)") == 0) {
         synthContextSoundflower16ch.start( 0, Synth.DEFAULT_FRAME_RATE, i, maxChannelsIn, i, maxChannelsOut );
       } 
       
    }
  }
  
}


/* DRAW */
void draw() {
  background(0);

  // 
  if (startTest==0) {
    
    //
    int outDevID01=3;
    int outDevID02=4;
    int channelOut01=0;
    int channelOut02=3;
    int channelIn=4;
    String fileName01 ="/path/to/your/audiofile/monoTest01.wav";
    String fileName02 ="/path/to/your/audiofile/monoTest02.wav";


    // Start Audio on device MAYA44_01
    File sampleFile01 = new File(fileName01);
    startAudio(synthContextMAYA44_01,outDevID01,channelOut01,sampleFile01);
    
    // Start Audio on device MAYA44_02
    File sampleFile02 = new File(fileName02);
    startAudio(synthContextMAYA44_02,outDevID02,channelOut02, sampleFile02);
    
    // Start Audio on device MAYA44_01
    sampleFile01 = new File(fileName02);
    startAudio(synthContextMAYA44_01,outDevID01,channelOut01+2,sampleFile01);
    
    startTest=1;
  }
  
  // check streamer ArrayList
  streamerList();
  
}



void startAudio(SynthContext synthContextOut, int outDevID, int channelOut, File sampleFile) {
 
  /** Create a streamer for the specified file.
  * File header will be read for info needed for streaming.
  */
  try {
    // Load sample from a file.
    SampleFileStreamer streamerTMP = new SampleFileStreamer(sampleFile, synthContextOut, outDevID, channelOut);
    // start streaming
    streamerTMP.startStream();
    // add streaming-object to array
    streamer.add(streamerTMP);
  } catch (IOException exc) {
    exc.printStackTrace(System.err);
    throw new RuntimeException(exc.getMessage());
  }
     
}


void streamerList() {
  
  //streamer
  for( Iterator i = streamer.iterator();i.hasNext();) {
    
    SampleFileStreamer streamerTMP = (SampleFileStreamer) i.next();      
    try {
      if ( streamerTMP.sendBuffer() < 200 ) {
      
      // stop streamer
      try {
        streamerTMP.stopStream();

         // Delete unit peers.
         //((SampleFileStreamer) i.next()).delete();
         //((SampleFileStreamer) i.next()) = null;
         streamerTMP.delete();
         i.remove();
         removeAll(); // remove portFaders
     } catch (SynthException e) {
         SynthAlert.showError(this, e);
     }
      
      }
    } catch(IOException e) {
      System.out.println(e.getMessage());
    }
  }
  
}





void stop() {
  
  // stop synthContext                
  try {    
    synthContextDefaultOut.stop();
    synthContextDefaultIn.stop();
    synthContextMAYA44_01.stop();
    synthContextMAYA44_02.stop();
    synthContextSoundflower16ch.stop();
    synthContextOut.stop();
  
    synthContextDefaultOut.delete();
    synthContextDefaultIn.delete();
    synthContextMAYA44_01.delete();
    synthContextMAYA44_02.delete();
    synthContextSoundflower16ch.delete();
    synthContextOut.delete();
  } catch( SynthException e ) {
    SynthAlert.showError( this, e );
  }
  
  try {
    // Turn off tracing.
    Synth.verbosity = Synth.SILENT;
    // Stop synthesis engine.
    Synth.stopEngine();
  } catch (SynthException e) {
     SynthAlert.showError(this, e);
  }
 
}


// audio helper functions
int[] getMaxChannels( int id ) {
  int maxChannels[] = new int[2];
  maxChannels[0] = AudioDevice.getMaxInputChannels( id );
  maxChannels[1] = AudioDevice.getMaxOutputChannels( id );
  return maxChannels;
}

// DeviceItem class
class DeviceItem {
  String name;
  int maxChannelsIn;
  int maxChannelsOut;
  int devID;
  int mode;

  DeviceItem(int pDevID, String pName, int pMaxChannelsIn, int pMaxChannelsOut) {
    devID = pDevID;
    name = pName;
    maxChannelsIn = pMaxChannelsIn;
    maxChannelsOut = pMaxChannelsOut;
  }

  // 
  public String toString() {
    return name + " - deviceID: " + devID + " - max.ChannelsIn [" + maxChannelsIn + "]" + " - max.ChannelsOut [" + maxChannelsOut + "]";
  }
  
  // return deviceID
  int getDeviceID() {
    return devID;
  }
  
  // return max.Channels
  int getMaxChannels(int mode) {
    int maxChannels = (mode == INPUT_MODE) ? AudioDevice.getMaxInputChannels( devID ) : AudioDevice.getMaxOutputChannels( devID );
    return maxChannels;
  }

  // return ChannelsIn
  int getNumChannelsIn() {
    int numChannels = 0;

    if( devID != Synth.NO_DEVICE ) {
      int maxChannels = getMaxChannels( 0 );
      if( (numChannels <= 0) || (numChannels > maxChannels) ) {
        numChannels = maxChannels;
        //setNumChannels( numChannels );
       }
     }
    return numChannels;
  }
  
  // return ChannelsOut
  int getNumChannelsOut() {
    int numChannels = 0;

    if( devID != Synth.NO_DEVICE ) {
      int maxChannels = getMaxChannels( 1 );
      if( (numChannels <= 0) || (numChannels > maxChannels) ) {
        numChannels = maxChannels;
        //setNumChannels( numChannels );
       }
     }
    return numChannels;
  }

  // return deviceName
  int getSelectedDeviceID(String deviceName)  {
    DeviceItem item = (DeviceItem) namesToDevice.get( deviceName );
    return item.getDeviceID();
  }
  
}











// SampleFileStreamer class 
// streaming mono-soundfiles on certain channels
class SampleFileStreamer extends SynthCircuit implements Runnable {
	public SynthSample mySamp;
	SampleReader mySampler;
	final static int FRAMES_PER_BLOCK = 400;
	// number of frames to synthesize at one time
	final static int FRAMES_IN_BUFFER = 8 * 1024;
	int numChannels = 1;	
	int samplesPerBlock;
	short[] data;
	SampleQueueOutputStream outStream;
	Thread thread;
	SynthInput amplitude;
	File sampleFile;
	InputStream inStream;
	int numFrames;
	int frameCursor;
        
        // synthContext
        SynthContext synthContextOut;
        // channels    
        ChannelOut outputChannel;

        // device
        int deviceID;
        // channels
        int channelIn;
        int channelOut;
        

	/** Create a streamer for the specified file.
	 * File header will be read for info needed for streaming.
	 */
  	public SampleFileStreamer(File file, SynthContext pSynthContextOut, int pDeviceID, int pChannelOut) throws IOException {
  		super();
		sampleFile = file;
		InputStream stream = new FileInputStream(file);

                synthContextOut = pSynthContextOut;
                deviceID=pDeviceID;
                channelOut=pChannelOut;

		setup(stream);
	}

	/** Analyse sample header and create appropriate player. */
	private void setup(InputStream stream) throws IOException { 
           
		BufferedInputStream bufStream = new BufferedInputStream(stream);
		mySamp = new SynthSampleWAV();

		// Preload to get offset to data and other sample info.
		// The false flag means do not load the actual WAV data at this time.
		mySamp.load(bufStream, false);
		mySamp.dump();

		bufStream.close();

		numChannels = mySamp.getChannelsPerFrame();
		numFrames = mySamp.getNumFrames();
             
		// Create SynthUnits to play sample data.
                mySampler = new SampleReader_16F1(synthContextOut);
  
                // Open Channel
                outputChannel = new ChannelOut( synthContextOut, channelOut );
                // Start execution of units.
                outputChannel.start();
                mySampler.output.connect(0, outputChannel.input, 0);    
                
		add(mySampler); 

		samplesPerBlock = FRAMES_PER_BLOCK * numChannels;
		data = new short[samplesPerBlock];
		addPort(amplitude = mySampler.amplitude);

		// Create a stream that we can write to.
		outStream =  new SampleQueueOutputStream(mySampler.samplePort,FRAMES_IN_BUFFER,numChannels);
	}
        
        
	public SynthOutput getOutput() {
		return mySampler.output;
	}

        public double showOutput() {
                double outVal = mySampler.output.get();
                return outVal;
        }
        

	/** Thread task that plays a file from disk. */
	public void run() {
		try {
			try {
				while (thread != null) {
					if( sendBuffer() <= 0 ) break;
				}
			} finally {
				outStream.flush();
				inStream.close();
			}
		} catch (IOException e) {
			System.out.println("run() caught " + e);
		} catch (SynthException e) {
			System.out.println("run() caught " + e);
		}
	}

	/** Read data from file and write it to the audio output stream.
	 * @return framesLeft;
	 */
	int sendBuffer() throws IOException {
		int samplesToRead = samplesPerBlock;
		int framesLeft = numFrames - frameCursor;
		int samplesLeft = framesLeft * numChannels;
		if (samplesToRead > samplesLeft)
			samplesToRead = samplesLeft;
		int i = 0;

		// Read sample data from file as bytes and assemble into 16 bit samples.
		while (i < samplesToRead) {
			int sample = inStream.read(); // get LSB
			if (sample < 0) {
				throw new IOException("Premature EOF");
			}
				sample = (inStream.read() << 8) // MSB
	| (sample & 0x00FF);
			data[i++] = (short) sample;
		}

		if (i > 0) {
			int framesRead = i / numChannels;
			frameCursor += framesRead;
			// Write data to the stream.
			// Will block if there is not enough room so run in a thread.
			outStream.write(data, 0, framesRead);
		}
		return framesLeft;
	}

	/** Start playing the stream in the background thread. */
	void startStream() {
		try {
			FileInputStream fileStream = new FileInputStream(sampleFile);
			inStream = new BufferedInputStream(fileStream);

			// Skip to where the sample data starts.
			inStream.skip(mySamp.getOffset());

			frameCursor = 0;
			// Prefill output stream buffer so that it starts out full.
			while (outStream.available() > FRAMES_PER_BLOCK)
				sendBuffer();
			// Start slightly in the future so everything is synced.
			int time = Synth.getTickCount() + 4;
			mySampler.start(time);
			outStream.start(time);

			// launch a thread to keep stream supplied with data
			thread = new Thread(this);
			thread.start();
		} catch (IOException exc) {
			System.err.println(exc.toString());
		}
	}

	/** Stop playing the stream and wait for data to flush. */
	void stopStream() {
            
                outputChannel.stop();
                outputChannel.delete();
                
		Thread myThread = thread;
		if (thread != null) {
			thread = null; // tells thread to stop!
			try {
				myThread.join(1000);
			} catch (InterruptedException e) {
			}
			int time = Synth.getTickCount();
			outStream.stop(time);
			mySampler.stop(time);
		}
	}
}


